' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/13 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    Private Const PI As Double = 3.14159265358979

    '͈
    Public m_ExeRegion As New FvRectangle

    'xOioj
    Public m_intArrange As Integer

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'Fݒ
        With cmbColor
            .Items.Add("BLACK")
            .Items.Add("WHITE")
            .SelectedIndex = 0
        End With

        'o
        rbtArrange0.Checked = True
        m_intArrange = 0

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImageOrg.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImageOrg.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImageOrg.GetOcx())

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - txtResult.Height - 55
            AxFvxDisplayEx1.Size = newSize

            txtResult.Width = AxFvxDisplayEx1.Width
            txtResult.Top = AxFvxDisplayEx1.Top + AxFvxDisplayEx1.Height + 10
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    'J摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImageOrg.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImageOrg.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImageOrg.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImageOrg.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImageOrg.BitPerPixel <> 8 Or AxFvxImageOrg.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImageOrg.BitPerPixel = 8
                AxFvxImageOrg.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImageOrg.ImageWidth = 512
                AxFvxImageOrg.ImageHeight = 480
            End If

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImageOrg.GetOcx())
        End If

    End Sub

    '\摜̕ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImageOrg.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    '2ls
    Private Sub btnApplyBinLevel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApplyBinLevel.Click

        Dim intBinLevel As Integer

        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0

        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255


        If AxFvxImageOrg.BitPerPixel = 8 Then
            'ChangeImage𗘗păOCImage2lImage
            AxFvxChangeImage1.FixedLevel(AxFvxImageOrg.GetOcx(), AxFvxImageBin.GetOcx(), intBinLevel)
        Else
            MsgBox("8bitZW摜ł͂܂")
            AxFvxImageOrg.CopyTo(AxFvxImageBin.GetOcx())
        End If

        AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImageBin.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If

            AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            AxFvxDisplayEx1.DrawData(0, m_ExeRegion)
        End If

    End Sub

    'vʃNA
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click

        AxFvxDisplayEx1.DrawImage(AxFvxImageOrg.GetOcx())
        AxFvxDisplayEx1.ClearOverlay()
        txtResult.Text = ""

    End Sub

    '2lvs
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim i As Integer
        Dim j As Integer

        Dim dblTime As Double   '
        Dim intErr As Integer   'G[ԍ

        Dim intBinLevel As Integer '2l臒l
        Dim intMinSize As Integer  'ŏʐ
        Dim intMaxSize As Integer  'őʐ

        Dim intDivideNum As Integer    'ʐϔ͈͕
        Dim intSizeStep() As Integer   'ʐϕ臂ƂȂl
        Dim intBlobNum() As Integer    'ꂽʐϔ͈͂ƂBlob̐

        Dim intCount As Integer        'Blob̌
        Dim pBlobResultGroup As New FvBlobResultGroup '2lv


        'ʏ
        AxFvxDisplayEx1.ClearOverlay()

        '`FbN
        If Integer.TryParse(txtDivideNum.Text, intDivideNum) = False Or intDivideNum < 2 Then
            MsgBox("2ȏ̐lw肵Ă", vbExclamation, "G[")
            Exit Sub
        End If

        'őEŏʐϒl`FbN
        If Integer.TryParse(txtMinSize.Text, intMinSize) = False Or intMinSize < 1 Then
            MsgBox("ŏʐϒl1ȏ̐lݒ肵Ă", , "p[^G[")
            Exit Sub
        End If
        If Integer.TryParse(txtMaxSize.Text, intMaxSize) = False Or intMinSize >= intMaxSize Then
            MsgBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă", , "p[^G[")
            Exit Sub
        End If

        'n_ƏI_KvȂ̂ŁA+1ϐKv
        ReDim intSizeStep(intDivideNum + 1)
        ReDim intBlobNum(intDivideNum + 1)

        'ʐϕn_̌vZ
        For i = 0 To intDivideNum
            intSizeStep(i) = intMinSize + (intMaxSize - intMinSize) * i / intDivideNum
        Next

        'őEŏʐϐݒ
        AxFvxBlob1.MinSize = intMinSize
        AxFvxBlob1.MaxSize = intMaxSize

        'ΏېFݒ
        If cmbColor.Text = "BLACK" Then
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.BLACK_COLOR
        Else
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.WHITE_COLOR
        End If

        'xOiojݒ
        AxFvxBlob1.Arrange = m_intArrange

        '͈͐ڐG
        If chkWndTouch.Checked = True Then
            AxFvxBlob1.WindowTouch = 1 'ON
        Else
            AxFvxBlob1.WindowTouch = 0 'OFF
        End If

        '臒l`FbN
        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0
        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255

        '2l
        If AxFvxImageOrg.BitPerPixel = 8 Then
            AxFvxChangeImage1.FixedLevel(AxFvxImageOrg.GetOcx(), AxFvxImageBin.GetOcx(), intBinLevel)
        ElseIf AxFvxImageOrg.BitPerPixel = 1 Then
            AxFvxImageOrg.CopyTo(AxFvxImageBin.GetOcx())
        Else
            MsgBox("BPP=1/8ȊỎ摜͂܂", , "͉摜G[")
            Exit Sub
        End If
        AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())

        '͈͐ݒ
        AxFvxBlob1.SetInspectArea(m_ExeRegion)
        '͈͂Ԃŕ`
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
        AxFvxDisplayEx1.DrawData(0, m_ExeRegion)


        Try
            '----------------------------------------------------------------
            'ԑJn
            AxFvxPerformanceCounter1.StartCount()

            'Qlvs
            AxFvxBlob1.Execute(AxFvxImageBin.GetOcx(), intCount)

            '----------------------------------------------------------------
            'ԑI
            AxFvxPerformanceCounter1.StopCount(dblTime)


            AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

            'ʂ̎擾
            'xxResultGroupɂČʂ󂯎ꍇɂ́A͖܂B
            AxFvxBlob1.GetResult(0, pBlobResultGroup)

            'dS_ƊOڒ``悵܂
            AxFvxDisplayEx1.DrawData(0, pBlobResultGroup)

            For i = 0 To pBlobResultGroup.Count - 1
                'blobǂ̖ʐϔ͈͂ɑĂ邩ׁA̐L^܂
                For j = 0 To intDivideNum - 1
                    If (intSizeStep(j) <= pBlobResultGroup.Item(i).area) And (pBlobResultGroup.Item(i).area < intSizeStep(j + 1)) Then
                        intBlobNum(j) = intBlobNum(j) + 1
                    End If
                Next
            Next

            'ʂeLXg{bNXɕ\܂
            txtResult.Text = " : " & VisualBasic.Format(dblTime, "0.00ms") & vbCrLf & _
                            "o : " & intCount & vbCrLf & vbCrLf & _
                            "ʐϔ͈           " & vbCrLf
            For j = 0 To intDivideNum - 1
                txtResult.Text = txtResult.Text & VisualBasic.Format(intSizeStep(j), "0").PadLeft(6) & _
                                    " ` " & VisualBasic.Format(intSizeStep(j + 1), "0").PadLeft(6) & _
                                    " : " & VisualBasic.Format(intBlobNum(j), "0").PadLeft(4) & vbCrLf
            Next
        Catch ex As Exception
            'G[oĂ邩mF
            'VBWErrIuWFNgł̓G[ԍ擾ł܂B
            'KGetErrReport\bhgăG[ԍ擾Ă
            AxFvxBlob1.GetErrReport(intErr)
            MsgBox("G[:" & intErr, vbExclamation, "G[")
        End Try

    End Sub

    Private Sub rbtArrange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtArrange7.Click, rbtArrange6.Click, rbtArrange5.Click, rbtArrange4.Click, rbtArrange3.Click, rbtArrange2.Click, rbtArrange1.Click, rbtArrange0.Click

        Dim strTemp As String

        strTemp = VisualBasic.Right(sender.name, 1)
        m_intArrange = Integer.Parse(strTemp)

    End Sub

    Private Sub txtBinLevel_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtMinSize.KeyPress, txtMaxSize.KeyPress, txtDivideNum.KeyPress, txtBinLevel.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
